package overlay

import (
	"git.d3nexus.de/Dadido3/D3vugu-components/components/navigation"
	"github.com/vugu/vugu"
)

// Container can be embedded in your root component and provides a way to show overlays like modals and toasts.
type Container struct {
	modal      vugu.Builder `vugu:"data"`
	modalTitle string
}

func (c *Container) handleModalClose(event vugu.DOMEvent) {
	c.modal = nil
}

func (c *Container) SetModal(component vugu.Builder) {
	c.modal = component

	c.modalTitle = ""
	// Retrieve title from component if it implements the PageTitleGetter interface.
	if pageInfo, ok := component.(navigation.PageTitleGetter); ok {
		c.modalTitle, _, _ = pageInfo.PageTitle()
	}
}

type OverlayContainerRef struct {
	*Container
}

func (p *OverlayContainerRef) OverlayContainerSet(container *Container) {
	p.Container = container
}

type OverlayContainerSetter interface {
	OverlayContainerSet(*Container)
}

var _ OverlayContainerSetter = &OverlayContainerRef{}
