package overlay

import (
	"git.d3nexus.de/Dadido3/D3vugu-components/components/input"
	"github.com/vugu/vugu"
)

type ModalRequester struct {
	OverlayContainerRef

	SymbolSlot vugu.Builder `vugu:"data"` // Slot for the symbol.

	Title   string `vugu:"data"`
	Message string `vugu:"data"`

	ClickAbort input.ClickHandler
	ClickYes   input.ClickHandler
}

func (c *ModalRequester) handleClickAbort(event vugu.DOMEvent) {
	if c.ClickAbort != nil {
		c.ClickAbort.ClickHandle(input.ClickEvent{DOMEvent: event})
	}
	c.SetModal(nil)
}

func (c *ModalRequester) handleClickYes(event vugu.DOMEvent) {
	if c.ClickYes != nil {
		c.ClickYes.ClickHandle(input.ClickEvent{DOMEvent: event})
	}
	c.SetModal(nil)
}

// PageTitle implements PageTitleGetter which is used by PageInfo.
func (c *ModalRequester) PageTitle() (title, longTitle, shortTitle string) {
	return c.Title, c.Title, c.Title
}
